<template>
  <div class="tbcc-overview">
    <p class="tbcc-overview__description">{{ $t('text') }}</p>
    <div class="overview">
      <div class="overview__graph">
        <tbcc-tabs />
      </div>
      <div class="overview__info info">
        <p class="info__price">
          ${{ price }} <span :class='["info__change", {"info__change--negative": isNegativePercentage}]'>{{ percentChange }}%</span>
        </p>
        <div class="info__min-max">
          <p>
            Low: <span>${{ lowPrice }}</span>
          </p>
          <p>
            High: <span>${{ highPrice }}</span>
          </p>
        </div>
        <div class="info__address">
          <p id="content-holder">0xf29480344d8e21efeab7fde39f8d8299056a7fea</p>
          <p>
            Binance Smart Chain (BEP20): &nbsp;
            <span>0xf2...7fea</span>&nbsp;<copy-button
              id="copy-button"
              aria-label="copy address"
            />
          </p>
        </div>
        <div class="info__actions">
          <a href="https://www.tbcc.com/markets" target="_blank">
            <base-button>
              {{ $t('viewBtn') }}
            </base-button>
          </a>
          <base-button class="meta-mask-button">
            {{ $t('metaBtn') }}
          </base-button>
        </div>
        <p class="info__copyright">Data by TBCC</p>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import BaseButton from '../base/BaseButton'
import TbccTabs from './TbccTabs'
import CopyButton from './CopyButton'
export default {
  components: { BaseButton, CopyButton, TbccTabs },

  computed: {
    ...mapGetters({
      price: 'getPrice',
      percentChange: 'getPercentChange',
      highPrice: 'getHighPrice',
      lowPrice: 'getLowPrice',
    }),

    isNegativePercentage() {
      return this.percentChange < 0
    },
  },

  mounted() {
    const button = document.getElementById('copy-button')
    const contentHolder = document.getElementById('content-holder')

    button.addEventListener('click', function () {
      const range = document.createRange()
      const selection = window.getSelection()
      selection.removeAllRanges()
      range.selectNodeContents(contentHolder)
      selection.addRange(range)
      document.execCommand('copy')
      selection.removeAllRanges()
    })
  },
}
</script>

<i18n>
{
  "en": {
    "text": "The market price of the TBCC token is based on the demand, that is why it can't be stable or backed by anything.",
    "viewBtn": "View Markets",
    "metaBtn": "Add to MetaMask"
  },
  "ch": {
    "text": "TBCC代币的市场价格是基于需求，这就是为什么它不能稳定或有任何支持。",
    "viewBtn": "查看市场",
    "metaBtn": "添加到MetaMask"
  },
  "tur": {
    "text": "The market price of the TBCC token is based on the demand, that is why it can't be stable or backed by anything. ",
    "viewBtn": "View Markets",
    "metaBtn": "Add to MetaMask"
  }
}
</i18n>

<style lang="scss" scoped>
.tbcc-overview {
  display: flex;
  align-items: center;
  flex-direction: column;

  &__description {
    font-weight: 400;
    font-size: 17px;
    color: #05204a;
    opacity: 0.6;
    max-width: 680px;
    text-align: center;
    margin: 0 0 40px;
  }
}

.overview {
  width: 100%;
  background: transparent;
  border-radius: 16px;
  display: flex;
  flex-direction: column;
  max-width: 485px;

  @media (min-width: 768px) {
    max-width: 715px;
    background-color: #dbe1f1;
  }

  @media (min-width: 1024px) {
    border-radius: 36px;
    flex-direction: row;
    max-width: unset;
  }

  &__graph,
  &__info {
    width: 100%;
    max-width: 100%;

    @media (min-width: 1024px) {
      width: 50%;
      max-width: 50%;
    }
  }
}

.info {
  padding-top: 56px;

  @media (min-width: 1024px) {
    padding-top: 35px;
    padding-left: 50px;
  }

  &__price {
    font-weight: 700;
    font-size: 36px;
    line-height: 45px;
    color: #2b2b2b;
    display: inline-flex;
    align-items: center;
    letter-spacing: -0.2px;
    margin: 0 0 30px;

    @media (min-width: 1024px) {
      margin: 0 0 40px;
    }
  }

  &__change {
    font-weight: 500;
    font-size: 20px;
    line-height: 24px;
    color: white;
    display: inline-block;
    background: linear-gradient(77.9deg, #0066ff -3.83%, #2ce0c5 110.36%);
    border-radius: 10px;
    padding: 8px 10px 8px 28px;
    margin-left: 18px;
    position: relative;

    &::after {
      content: '';
      background-image: url('../../assets/img/vectorUp.svg');
      width: 12px;
      height: 7px;
      background-position: center;
      background-repeat: no-repeat;
      position: absolute;
      left: 10px;
      top: 50%;
      transform: translateY(-50%);
    }

    &--negative {
      &::after {
        transform: translateY(-50%) rotate(180deg);
      }
    }
  }

  &__min-max {
    display: flex;
    margin-bottom: 20px;

    @media (min-width: 768px) {
      margin-bottom: 35px;
    }

    p {
      font-weight: 400;
      font-size: 16px;
      line-height: 19px;
      color: #6983ab;
      margin: 0;

      @media (min-width: 768px) {
        font-size: 20px;
        line-height: 24px;
      }

      &:first-child {
        margin-right: 27px;
      }
    }

    span {
      margin-left: 6px;
      color: #435c82;
    }
  }

  &__address {
    display: flex;
    margin-bottom: 30px;

    p {
      font-weight: 400;
      font-size: 16px;
      line-height: 19px;
      color: #6983ab;
      margin: 0;

      @media (min-width: 768px) {
        font-size: 20px;
        line-height: 24px;
      }
    }

    span {
      color: #435c82;
    }
  }

  &__actions {
    position: relative;
    z-index: 1;
    margin-bottom: 30px;
    display: flex;
    flex-direction: column;
    align-items: center;

    @media (min-width: 768px) {
      display: block;
    }

    @media (min-width: 1024px) {
      margin-bottom: 55px;
    }

    a {
      display: inline-block;
    }

    a:first-child {
      margin-bottom: 25px;

      @media (min-width: 768px) {
        margin-bottom: 0;
        margin-right: 20px;
      }

      @media (min-width: 1024px) {
        margin-right: 5px;
      }

      @media (min-width: 1280px) {
        margin-right: 20px;
      }
    }

    button {
      background: #e2e7f8;
      color: #2b2b2b;
      font-weight: 600;
      font-size: 16px;
      line-height: 16px;
      min-width: 318px;
      justify-content: center;
      padding: 20px 27px;

      @media (min-width: 768px) {
        min-width: unset;
      }
    }
  }

  &__copyright {
    font-weight: 600;
    font-size: 16px;
    line-height: 20px;
    color: #43597c;
    opacity: 0.35;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: 100%;
    margin: 0;

    @media (min-width: 768px) {
      width: unset;
      justify-content: flex-start;
    }

    svg {
      margin-left: 10px;
    }
  }
}

#copy-button {
  position: relative;
  top: 8px;
  display: inline-block;
}

#content-holder {
  position: absolute;
  color: transparent;
  z-index: -1;
  font-size: 0;
}

.meta-mask-button {
  padding-left: 40px !important;
  padding-right: 20px !important;
  position: relative;

  @media (min-width: 1024px) {
    margin-top: 20px;
  }

  @media (min-width: 768px) {
    padding-left: 50px !important;
    padding-right: 17px !important;
  }

  &::after {
    content: '';
    position: absolute;
    width: 24px;
    height: 24px;
    background-image: url('../../assets/img/meta-mask.svg');
    background-position: center;
    background-repeat: no-repeat;
    left: 75px;
    top: 50%;
    transform: translateY(-50%);

    @media (min-width: 768px) {
      left: 20px;
    }
  }

  &::before {
    background: #a8b8ce;
  }

  &:hover {
    &::before {
      background: #8d9bad;
    }
  }
}
</style>
